/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#include "veclib.h"

#include <math.h>

VecLib::VecLib()
{}


VecLib::~VecLib()
{}

double VecLib::v2SquaredLength( double x, double y )
{
  return((x * x)+(y * y));
}

double VecLib::v2Length( double x, double y )
{
  return(sqrt(VecLib::v2SquaredLength(x,y)));
}

void VecLib::v2Normalize( double & x, double & y )
{
  double len = VecLib::v2Length(x, y);
  if (len != 0.0) { x /= len;  y /= len; }
}

double VecLib::v2Dot( double x1, double y1, double x2, double y2 )
{
  return((x1*x2)+(y1*y2));
}

void VecLib::v2Scale( double & x, double & y, double newlen )
{
  double len = VecLib::v2Length(x, y);
  if (len != 0.0) { x *= newlen/len;   y *= newlen/len; }
}
/*
void VecLib::v2Combine(double x1, double y1, double x2, double y2,
                       double& resultX, double& resultY,
                       double ascl, double bscl)
{
  resultX = (ascl * x1) + (bscl * x2);
  resultY = (ascl * y1) + (bscl * y2);
}*/
